# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
#		Makefile for Domino COM C++ sample program CppAPI
#		Builds the sample CppAPI for Win32 platforms
#		(Windows 95, Windows NT)
#
#   This makefile assumes that the INCLUDE and LIB environment 
#   variables are set up to point at the Notes C++ and C "include"
#   and "lib" directories.
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

# Standard Windows NT make definitions
!include <win32.mak>

# The name of the program.
PROGNAME = CppAPI

# The source directory where domobj_i.c is at.
DOM_SRCE=$(DTCOM)\source

# Dependencies
$(PROGNAME).exe: $(PROGNAME).obj $(DOM_SRCE)\domobj_i.obj
$(PROGNAME).obj: $(PROGNAME).cpp
$(DOM_SRCE)\domobj_i.obj: $(DOM_SRCE)\domobj_i.c

# Compilation command.  
.cpp.obj:
   $(cc) -c -W3 -nologo -GX -MT -DW32 -DNODLL \
        -D_X86_=1 -Zp1 $*.cpp

.c.obj:
   $(cc) -c -W3 -nologo -Fo$*.obj -GX -MT -DW32 -DNODLL \
        -D_X86_=1 -Zp1 $*.c

# Link command.
.obj.exe:
    $(link) comctl32.lib comdlg32.lib gdi32.lib kernel32.lib libcimt.lib \
        ole32.lib oleaut32.lib shell32.lib user32.lib uuid.lib \
        winspool.lib notescpp.lib $(linkdebug) $(conflags) -out:$@ $** $(conlibsmt)



