// DbDirDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DbDir.h"
#include "DbDirDlg.h"
#include "domobj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbDirDlg dialog

CDbDirDlg::CDbDirDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDbDirDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDbDirDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDbDirDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDbDirDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDbDirDlg, CDialog)
	//{{AFX_MSG_MAP(CDbDirDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GET_DB_PROP_CMD, OnGetDbPropCmd)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DISPLAY_TITLES_CHK, OnDisplayTitlesChkClick)
	ON_LBN_DBLCLK(IDC_DATABASE_LIST, OnDblclkDatabaseList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbDirDlg message handlers

BOOL CDbDirDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    // Return Status from COM calls.
    HRESULT hr;

    // Initialize COM Library.
    hr = CoInitialize(NULL);
    if (FAILED(hr)) 
    {
        AfxMessageBox ("Unable to Initialize COM!", MB_ICONEXCLAMATION );
        return false;
    }

    // Instantiate NotesSession interface.
    hr = CoCreateInstance(
        CLSID_NotesSession,     // Class Identifier 
        NULL,                   // No Aggregate Object
        CLSCTX_INPROC_SERVER,   // Local In process
        IID_ISession,           // Interface
        (LPVOID*)&m_pSession); // A pointer to the interface.
    if (FAILED(hr)) 
    {
        AfxMessageBox ("Unable to Create a NotesSession Object!", MB_ICONEXCLAMATION );
        return false;
    }

    // Initialize the NotesSession.    
    hr = m_pSession->Initialize(NULL);
    if (FAILED(hr))
    {
        AfxMessageBox ("Unable to Initialize Notes!", MB_ICONEXCLAMATION );
        return false;
    }

    m_plbDatabase = (CListBox*)GetDlgItem(IDC_DATABASE_LIST);

    GetNotesDatabases();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDbDirDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDbDirDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDbDirDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDbDirDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
   // Release the NotesSession.
   m_pSession->Release();
  
   // Close the COM Library and free resource.
   CoUninitialize();		
}

// Display Titles - Check Box Click event.
void CDbDirDlg::OnDisplayTitlesChkClick() 
{
	GetNotesDatabases();	
}

// Database - List Box Double Click event.
void CDbDirDlg::OnDblclkDatabaseList() 
{
	GetDatabasesProperties();
}

// Get Database Properties - Command Button Click event.
void CDbDirDlg::OnGetDbPropCmd() 
{
    GetDatabasesProperties();  
}


void CDbDirDlg::GetNotesDatabases()
{
   
    IDbDirectory* pDbDirectory = NULL;
    IDatabase* pDatabase = NULL; 
    HRESULT hr = 0;

    BSTR bstrServerName = NULL;   
    BSTR bstrDBPath = NULL;
    BSTR bstrDBTitle = NULL;
    CString strDBInfo;
    
    m_plbDatabase->ResetContent();
    
    hr = m_pSession->GetDbDirectory(bstrServerName, &pDbDirectory);

    if((hr == S_OK )&&(pDbDirectory != NULL))
        hr = pDbDirectory->GetFirstDatabase(DATABASE, &pDatabase);
 
    while ((hr == S_OK )&&(pDatabase != NULL))
    {  
        pDatabase->get_FilePath(&bstrDBPath);
        strDBInfo = bstrDBPath;
        strDBInfo.MakeLower();
        
        if(((CButton *)GetDlgItem(IDC_DISPLAY_TITLES_CHK))->GetCheck())
        {
            pDatabase->get_Title(&bstrDBTitle);
            strDBInfo += " (";  
            strDBInfo += bstrDBTitle; 
            strDBInfo += ")";
            if (bstrDBTitle) 
            {
                SysFreeString(bstrDBTitle);  
                bstrDBTitle = NULL;
            }
        }

        m_plbDatabase->AddString(strDBInfo);  
        if (bstrDBPath) 
        {
            SysFreeString(bstrDBPath);  
            bstrDBPath = NULL;
        }
        hr = pDbDirectory->GetNextDatabase(&pDatabase);

    }
  
    if (pDbDirectory) pDbDirectory->Release();
    if (pDatabase) pDatabase->Release();    
    
    if (bstrServerName) SysFreeString(bstrServerName);  
    if (bstrDBPath) SysFreeString(bstrDBPath);  
    if (bstrDBTitle) SysFreeString(bstrDBTitle);  
}

CString CDbDirDlg::GetDatabasesPathName()
{
    CString strDBFileName;  
    int iSelected = 0;

    iSelected = m_plbDatabase->GetCurSel();

    if(iSelected == LB_ERR)
        return "";

    m_plbDatabase->GetText(iSelected, strDBFileName);

    if(((CButton *)GetDlgItem(IDC_DISPLAY_TITLES_CHK))->GetCheck())
    {
        strDBFileName = strDBFileName.Left(strDBFileName.Find(".nsf (") + 4);
    }

    return(strDBFileName);
}

void CDbDirDlg::GetDatabasesProperties()
{
    IDatabase* pDatabase = NULL;

    BSTR bstrServerName = NULL;  
    BSTR bstrDBTitle = NULL;
    BSTR bstrDBName  = NULL;
    BSTR bstrDBPath  = NULL;
    BSTR bstrDBTemp  = NULL;
    BSTR bstrDBRepID = NULL;

    char buffer[256] = {0};
    double dDBSize  = 0;
    long lDBQuota = 0;

    HRESULT hr = 0;
   
    CString strMBInfo;  
    CString strMBTitle;
    CString strFilePath = GetDatabasesPathName(); 

    if(strFilePath.IsEmpty())
        return;

    bstrDBPath = strFilePath.AllocSysString();
        
    hr = m_pSession->GetDatabase(bstrServerName, bstrDBPath, false, &pDatabase);
    
    if (bstrDBPath)  SysFreeString(bstrDBPath); 

    if((hr == S_OK )&&(pDatabase != NULL))
    {
        pDatabase->get_Title(&bstrDBTitle);
        pDatabase->get_FileName(&bstrDBName);
        pDatabase->get_FilePath(&bstrDBPath);
        pDatabase->get_TemplateName(&bstrDBTemp);
        pDatabase->get_ReplicaID(&bstrDBRepID);
        pDatabase->get_Size(&dDBSize);
        pDatabase->get_SizeQuota(&lDBQuota);

        // Set Messagebox Info
        strMBInfo =  "Title:\t\t" ;
        strMBInfo += bstrDBTitle;
        strMBInfo += "\nFileName:     \t" ;
        strMBInfo += bstrDBName;
        strMBInfo += "\nFilePath:     \t" ;
        strMBInfo += bstrDBPath;
        strMBInfo += "\nTemplateName: \t" ;
        strMBInfo += bstrDBTemp;
        strMBInfo += "\nReplicaID:    \t" ;
        strMBInfo += bstrDBRepID;        
        sprintf( buffer, "\nSize:\t\t%.0f", dDBSize);
        strMBInfo += buffer;
        sprintf( buffer, "\nSizeQuota:    \t%ld", lDBQuota);
        strMBInfo += buffer;
    
        // Set Mesagebox Title
        strMBTitle = "Properties for [";
        strMBTitle += bstrDBTitle;
        strMBTitle += "]";

        MessageBox(strMBInfo, strMBTitle, MB_OK);
    }
    else
    {
        MessageBox("Unable to retrieve properties.", "Warning", MB_ICONINFORMATION);
    }    

    if (pDatabase) pDatabase->Release();  

    if (bstrServerName) SysFreeString(bstrServerName);
    if (bstrDBTitle) SysFreeString(bstrDBTitle);  
    if (bstrDBName)  SysFreeString(bstrDBName); 
    if (bstrDBPath)  SysFreeString(bstrDBPath);  
    if (bstrDBTemp)  SysFreeString(bstrDBTemp);  
    if (bstrDBRepID) SysFreeString(bstrDBRepID);      
}

