/*******************************************************************

  File:   	Intro.cpp 

  This program instantiates a NotesSession and displays the 
  current user name. It is designed to be used as a template 
  for COM development.

*******************************************************************/

#define UNICODE

#include <windows.h>
#include <stdio.h>

#include "domobj.h"

/*******************************************************************

  Function: main 
  
********************************************************************/
      
void main (int argc, char *argv[])
{
    // Return Status from COM calls.
    HRESULT hr;

    ISession* pSession = NULL;  
    BSTR bstrUserName = NULL;

    // Initialize COM library.
    hr = CoInitialize(NULL);
    if (FAILED(hr))
    {
        wprintf(L"Error initializing the COM library.");        
        return;
    }

    // Instantiate NotesSession interface.
    hr = CoCreateInstance(
      CLSID_NotesSession,
      NULL,
      CLSCTX_SERVER,
      IID_ISession, 
      (LPVOID*)&pSession);
    if (FAILED(hr))
    {
        wprintf(L"Error creating the NotesSession.");        
        goto Error;
    }

    // Initialize the NotesSession.    
    hr = pSession->Initialize(NULL);
    if (FAILED(hr))
    {
        wprintf(L"Error initializing the NotesSession.");        
        goto Error;
    }

    // Get the user name.
    pSession->get_UserName(&bstrUserName);

    // Print the user name.
    wprintf(L"Current User Name: %s\n", bstrUserName);    

    // Display the user name in a messagebox.
    MessageBox( NULL, bstrUserName, L"Current User Name", MB_OK);

    Error:
    // Free the BSTR.
    if (bstrUserName) SysFreeString(bstrUserName);

    // Release the NotesSession.
    pSession->Release();

    // Close the COM Library and free resource.
    CoUninitialize();	
}
