VERSION 5.00
Begin VB.Form frmDbDir 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VB Domino COM Sample"
   ClientHeight    =   3195
   ClientLeft      =   2415
   ClientTop       =   2265
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4905
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdGetDBs 
      Caption         =   "Get Database Properties"
      Height          =   495
      Left            =   1005
      TabIndex        =   2
      Top             =   2400
      Width           =   2895
   End
   Begin VB.CheckBox chkTitles 
      Caption         =   "Display Titles"
      Height          =   195
      Left            =   2880
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin VB.ListBox lstDomDb 
      Height          =   1620
      Left            =   345
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   480
      Width           =   4215
   End
End
Attribute VB_Name = "frmDbDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

' This function is called once when the form is loaded. It sets up the
' placement of the form and loads the controls.

    Width = Me.Width
    Height = Me.Height
    Left = (Screen.Width - Width) / 2   ' Center form horizontally.
    Top = (Screen.Height - Height) / 2   ' Center form vertically.

    Call GetNotesDatabases
        
End Sub


Private Sub GetNotesDatabases()

' Called in the form load and chkTitles_Click.
' Gets all the local databases.

On Error GoTo ErrorHandler

    Dim domSession As New NotesSession
    Dim domDbDirectory As NotesDbDirectory
    Dim domDatabase As NotesDatabase
    
    ' Initialize the NotesSession.
    domSession.Initialize
        
    Set domDbDirectory = domSession.GetDbDirectory("")
    Set domDatabase = domDbDirectory.GetFirstDatabase(Database)
    
    lstDomDb.Clear
    
    ' Get all the databases.
    While (Not domDatabase Is Nothing)
        If (chkTitles.Value) Then
            lstDomDb.AddItem LCase(domDatabase.FilePath) _
            & " (" & domDatabase.Title & ")"
        Else
            lstDomDb.AddItem LCase(domDatabase.FilePath)
        End If
        Set domDatabase = Nothing
        Set domDatabase = domDbDirectory.GetNextDatabase
    Wend
    
    lstDomDb.ListIndex = 0
    
    Exit Sub
    
ErrorHandler:

    Dim msg As String
    
    If Hex(Err.Number) = 80049728 Then
        msg = "Password is required."
    Else
        msg = "Unexpected error #" & Hex(Err.Number) & " occurred: " _
        & Err.Description
    End If
    
    ' Display message box with Stop sign icon and OK button.
    MsgBox msg, vbCritical
    Stop
    Unload Me
    
End Sub

Private Sub chkTitles_Click()

' This function is called once when the user clicks the Dispay Titles
' check box. It repopulates the database list box.

    Call GetNotesDatabases
    
End Sub

Private Sub GetDatabasesProperties(dbName As String)

' Called in the cmdGetDBs_Click and lstDomDb_DblClick.
' Displays the properties of a named database.

On Error GoTo ErrorHandler

    Dim domSession As New NotesSession
    Dim domDatabase As NotesDatabase
    Dim dbProperty As String
    Dim NL As String
    
    ' Initialize the NotesSession.
    domSession.Initialize
      
    NL = Chr(10) & Chr(13)
        
    Set domDatabase = domSession.GetDatabase("", dbName)
    
    ' Display the properties of the database.
    If domDatabase.IsOpen Then
        dbProperty = _
         "Title:" & Chr(9) & Chr(9) & domDatabase.Title & NL _
        & "FileName:     " & Chr(9) & domDatabase.FileName & NL _
        & "FilePath:     " & Chr(9) & domDatabase.FilePath & NL _
        & "TemplateName: " & Chr(9) & domDatabase.TemplateName & NL _
        & "ReplicaID:    " & Chr(9) & domDatabase.ReplicaID & NL _
        & "Size:" & Chr(9) & Chr(9) & domDatabase.Size & NL _
        & "SizeQuota:    " & Chr(9) & domDatabase.SizeQuota & NL

        MsgBox dbProperty, , "Properties for [" & domDatabase.Title & "]"
    Else
        MsgBox "Error opening database."
    End If
    
    Exit Sub
    
ErrorHandler:

    Dim msg As String
    
    msg = "Unexpected error #" & Hex(Err.Number) & " occurred: " _
    & Err.Description
    ' Display message box with Stop sign icon and OK button.
    MsgBox msg, vbCritical
    Stop
    
End Sub

Private Sub lstDomDb_DblClick()

' This function is called once when the user double clicks an item in the
' database list box. It displays the properties of the selected database.

    GetDatabasesProperties (GetDbFileName())
   
End Sub

Private Sub cmdGetDBs_Click()

' This function is called once when the user clicks Get Database Properties
' command button. It displays the properties of the selected database.

    GetDatabasesProperties (GetDbFileName())

End Sub

Private Function GetDbFileName()

' Gets the selected database name from list box.

    If (chkTitles.Value) Then
        GetDbFileName = Left(lstDomDb.Text, InStr(1, lstDomDb.Text, ".nsf (") + 3)
    Else
        GetDbFileName = lstDomDb.Text
    End If
    
End Function
