{==============================================================================|
| Project : Notes/Delphi class library                           | 3.10        |
|==============================================================================|
| Content:                                                                     |
|==============================================================================|
| The contents of this file are subject to the Mozilla Public License Ver. 1.0 |
| (the "License"); you may not use this file except in compliance with the     |
| License. You may obtain a copy of the License at http://www.mozilla.org/MPL/ |
|                                                                              |
| Software distributed under the License is distributed on an "AS IS" basis,   |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for |
| the specific language governing rights and limitations under the License.    |
|==============================================================================|
| Initial Developers of the Original Code are:                                 |
|   Daniel Lehtihet                                                            |
| All Rights Reserved.                                                         |
|   Last Modified:                                                             |
|     21.05.2002, Daniel Lehtihet                                              |
|==============================================================================|
| Contributors and Bug Corrections:                                            |
|==============================================================================|
| History: see README.TXT                                                      |
|==============================================================================|
| Server Add-in support unit                                                   |
| See LN API documentation for function description                            |
|                                                                              |
| Latest versions are available at                                             |
|   http://www.geocities.com/skolchin/                                         |
|==============================================================================|}
unit Util_NotesAddin;

interface
uses
  Windows, Util_LNApi;

const
  MAX_CONSOLE_CMD_LEN = 256;

type
  HMODULE = HANDLE;

{+// Service routines available to add-ins*/ }

function AddInIdle: Bool stdcall; far;
function AddInIdleDelay(Delay: LongInt): Bool stdcall; far;
function AddInSecondsHaveElapsed(Seconds: LongInt): Bool stdcall; far;

//const
//  AddInMinutesHaveElapsed(x) = AddInSecondsHaveElapsed((DWORD)(x)*60);
function AddInMinutesHaveElapsed(Minutes: LongInt ): Bool;
function AddInDayHasElapsed: Bool stdcall; far;
function AddInShouldTerminate: Bool stdcall; far;
procedure AddInFormatErrorText(retString: PChar;
                               aString: PChar) stdcall; far;
procedure AddInLogErrorText(aString: PChar;
                            AdditionalErrorCode: STATUS;
                            Arg: PChar) stdcall; far;

procedure AddInLogMessageText(aString: PChar;
                              AdditionalErrorCode: STATUS) stdcall; far;

procedure AddInSetStatusText(aString: PChar) stdcall; far;

{+// To Notes API customers (only): }
{-The following 5 functions ARE ONLY AVAILABLE ON PLATFORMS THAT }
{-SUPPORT USER-CREATED STRING RESOURCES. Since the Notes API does }
{-not provide a portable way to create customer-written string resources, }
{-THEY ARE NOT PORTABLE! Use the other variants of these routines }
{=which take "char*" rather than STATUS to achieve portability. }

procedure AddInFormatError(retString: PChar;
                           StringID: STATUS) stdcall; far;

procedure AddInLogError(StringID: STATUS;
                        AdditionalErrorCode: STATUS;
                        Arg: PChar) stdcall; far;
//const
//  AddInLogMsg(s, = e) AddInLogError(s, NOERROR, e);

procedure AddInLogMessage(StringID: STATUS;
                          AdditionalErrorCode: STATUS) stdcall; far;

procedure AddInSetStatus(StringID: STATUS) stdcall; far;

procedure AddInQueryDefaults(var rethModule: HMODULE;
                             var rethDesc: Handle) stdcall; far;

procedure AddInSetDefaults(hNewModule: HMODULE;
                           var hDesc: Handle) stdcall; far;

function AddInCreateStatusLine(TaskName: PChar): THandle stdcall; far;

procedure AddInDeleteStatusLine(hDesc: Handle) stdcall; far;

procedure AddInSetStatusLine(hDesc: Handle;
                             aString: PChar) stdcall; far;



implementation

function AddInIdle: Bool; external NOTES_DLL_NAME;

function AddInIdleDelay(Delay: LongInt): Bool; external NOTES_DLL_NAME;

function AddInSecondsHaveElapsed(Seconds: LongInt): Bool; external NOTES_DLL_NAME;

function AddInMinutesHaveElapsed(Minutes: LongInt ): Bool;
begin
    result := AddInSecondsHaveElapsed(DWORD(Minutes*60));
end;

function AddInDayHasElapsed: Bool; external NOTES_DLL_NAME;

function AddInShouldTerminate: Bool; external NOTES_DLL_NAME;

procedure AddInFormatErrorText(retString: PChar;
                               aString: PChar); external NOTES_DLL_NAME;

procedure AddInLogErrorText(aString: PChar;
                            AdditionalErrorCode: STATUS;
                            Arg: PChar); external NOTES_DLL_NAME;

procedure AddInLogMessageText(aString: PChar;
                              AdditionalErrorCode: STATUS); external NOTES_DLL_NAME;

procedure AddInSetStatusText(aString: PChar); external NOTES_DLL_NAME;

procedure AddInFormatError(retString: PChar;
                           StringID: STATUS); external NOTES_DLL_NAME;

procedure AddInLogError(StringID: STATUS;
                        AdditionalErrorCode: STATUS;
                        Arg: PChar); external NOTES_DLL_NAME;

procedure AddInLogMessage(StringID: STATUS;
                          AdditionalErrorCode: STATUS); external NOTES_DLL_NAME;

procedure AddInSetStatus(StringID: STATUS); external NOTES_DLL_NAME;

procedure AddInQueryDefaults(var rethModule: HMODULE;
                            var rethDesc: Handle); external NOTES_DLL_NAME;

procedure AddInSetDefaults(hNewModule: HMODULE;
                           var hDesc: Handle); external NOTES_DLL_NAME;

function AddInCreateStatusLine(TaskName: PChar): THandle; external NOTES_DLL_NAME;

procedure AddInDeleteStatusLine(hDesc: Handle); external NOTES_DLL_NAME;

procedure AddInSetStatusLine(hDesc: Handle;
                             aString: PChar); external NOTES_DLL_NAME;

end.
